"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.HttpAdapter = void 0;
require("reflect-metadata");
var _http = require("http");
var _https = require("https");
var inversify_1 = require("inversify");
var HttpAdapter = /** @class */ (function () {
    function HttpAdapter(config) {
        var _this = this;
        this.config = config;
        this.openConnection = function () {
            return Promise.resolve();
        };
        this.run = function (query) {
            return _this.httpRequest(query).then(function (result) {
                if (!!query.args && !!query.args["name"]) {
                    result = result[query.args["name"]];
                }
                if (query.sort)
                    result = _this.sortEntities(query, result);
                if (query.limit)
                    result = _this.limitEntities(query, result);
                return result;
            });
        };
        this.httpRequest = function (query) {
            return new Promise(function (res, err) {
                var lib = _this.config.apiBaseUri.startsWith('https') ? _https : _http;
                var request = lib.get("".concat(_this.config.apiBaseUri).concat(query.path), function (response) {
                    if (response.statusCode < 200 || response.statusCode > 299) {
                        err(new Error(response.statusMessage));
                    }
                    var body = [];
                    response.on('data', function (chunk) { return body.push(chunk); });
                    response.on('end', function (_) { return res(JSON.parse(body.join(''))); });
                });
                request.on('error', function (ex) { return err(ex); });
            });
        };
        this.sortEntities = function (query, entities) {
            var key = query.sort.key;
            var result = entities.sort(function (a, b) { return a[key] < b[key] ? -1 : 1; });
            if (query.sort.descending)
                result = result.reverse();
            return result;
        };
        this.limitEntities = function (query, entities) {
            if (entities.length <= query.limit)
                return entities;
            return entities.slice(0, query.limit);
        };
    }
    HttpAdapter = __decorate([
        (0, inversify_1.injectable)(),
        __metadata("design:paramtypes", [Object])
    ], HttpAdapter);
    return HttpAdapter;
}());
exports.HttpAdapter = HttpAdapter;
//# sourceMappingURL=http.adapter.js.map