"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.EventHandler = void 0;
var inversify_1 = require("inversify");
var app_composition_1 = require("../composition/app.composition");
var logger_1 = require("../logger");
var EventHandler = /** @class */ (function () {
    function EventHandler() {
        var _this = this;
        this.listen = function () {
            _this.eventService.subscribe(_this.event, function (data) {
                _this.processEvent(data).catch(function (ex) {
                    _this.logger.log(ex.message, logger_1.LogLevels.error);
                    process.exit(1);
                });
            });
        };
        this.alertFileAvailable = function (file) {
            _this.context.models.files.update(file.name, (function (file) {
                file.available = true;
                return file;
            }));
            return _this.context.saveChanges().then(function (_) {
                _this.logger.log("File '".concat(file.name, "' is now available."));
                _this.eventService.publish('file-available');
            });
        };
        this.eventService = app_composition_1.IoC.get(app_composition_1.TYPES.CompilerEvents);
        this.config = app_composition_1.IoC.get(app_composition_1.TYPES.WebsiteConfig);
        this.logger = app_composition_1.IoC.get(app_composition_1.TYPES.Logger);
        this.context = app_composition_1.IoC.get(app_composition_1.TYPES.CompilerDataContext);
    }
    EventHandler = __decorate([
        (0, inversify_1.injectable)(),
        __metadata("design:paramtypes", [])
    ], EventHandler);
    return EventHandler;
}());
exports.EventHandler = EventHandler;
//# sourceMappingURL=event-handler.js.map