"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Route = void 0;
var file_functions_1 = require("../functions/file.functions");
var Route = /** @class */ (function () {
    function Route(path, content, extension, extensionless) {
        if (extensionless === void 0) { extensionless = false; }
        this.path = path;
        this.content = content;
        this.extension = extension;
        this.mimeType = this.getmimeType(extension);
        if (extensionless)
            this.path = (0, file_functions_1.RemoveFileExtension)(path, 'html');
    }
    Route.prototype.getmimeType = function (extension) {
        switch (extension) {
            case "html": return 'text/html';
            case "js":
            case "min.js": return 'text/javascript';
            case "css":
            case "min.css": return "text/css";
            case "xml": return "application/xml";
        }
    };
    return Route;
}());
exports.Route = Route;
//# sourceMappingURL=route.js.map