import { AdapterConfig } from "./adapter-config";
export interface IWebsiteConfig {
    root?: string;
    logLevel?: string;
    production?: boolean;
    pages?: string[];
    partials?: string[];
    helpers?: string[];
    scripts?: string[];
    styles?: string[];
    assets?: string[];
    output?: string;
    serve?: boolean;
    sitemap?: SitemapConfig;
    adapter?: AdapterConfig;
    port?: number;
    handlebars?: (handlebars: any) => void;
}
export declare class WebsiteConfig {
    root: string;
    logLevel?: string;
    production?: boolean;
    pages?: string[];
    partials?: string[];
    helpers?: string[];
    scripts?: string[];
    styles?: string[];
    assets?: string[];
    output?: string;
    serve?: boolean;
    sitemap?: SitemapConfig;
    adapter?: AdapterConfig;
    port?: number;
    handlebars?: (handlebars: any) => void;
    constructor(config?: IWebsiteConfig);
    private assetGlobs;
    private get defaultAdapter();
}
export declare class SitemapConfig {
    hostname: string;
}
