import * as fsx from 'fs-extra';
import { FileData } from "../models";
export interface IFileImportService {
    importPartialFilesFromGlobs(): Promise<FileData[]>;
    importFilesFromGlobs(): Promise<FileData[]>;
    importFileText: (file: FileData) => Promise<FileData>;
    importAssetFilesFromGlobs: () => Promise<FileData[]>;
    importHelperFilesFromGlobs: () => Promise<FileData[]>;
}
export declare class FileImportService implements IFileImportService {
    fsx: typeof fsx;
    private config;
    private logger;
    private context;
    private globService;
    private eventService;
    private handlebarsService;
    constructor();
    importPartialFilesFromGlobs: () => Promise<FileData[]>;
    importFilesFromGlobs: () => Promise<FileData[]>;
    importAssetFilesFromGlobs: () => Promise<FileData[]>;
    importHelperFilesFromGlobs: () => Promise<FileData[]>;
    importFileText: (file: FileData) => Promise<FileData>;
    private addFilesToDatabase;
    private addAssetFilesToDatabase;
    private alertFileAdded;
}
